from _typeshed import Incomplete
from crispy_forms.utils import (
    TEMPLATE_PACK as TEMPLATE_PACK,
    flatatt as flatatt,
    render_field as render_field,
    list_difference as list_difference,
)
from crispy_forms.layout import Layout as Layout
from crispy_forms.exceptions import FormHelpersException as FormHelpersException
from crispy_forms.layout_slice import LayoutSlice as LayoutSlice

class DynamicLayoutHandler:
    def all(self): ...
    def filter(self, *LayoutClasses, max_level: int = 0, greedy: bool = False): ...
    def filter_by_widget(self, widget_type): ...
    def exclude_by_widget(self, widget_type): ...
    def __getitem__(self, key): ...
    def __setitem__(self, key, value) -> None: ...
    def __delitem__(self, key) -> None: ...
    def __len__(self) -> int: ...

class FormHelper(DynamicLayoutHandler):
    form: Incomplete
    form_id: str
    form_class: str
    form_group_wrapper_class: str
    layout: Incomplete
    form_tag: bool
    form_error_title: str
    formset_error_title: str
    form_show_errors: bool
    render_unmentioned_fields: bool
    render_hidden_fields: bool
    render_required_fields: bool
    form_show_labels: bool
    template: Incomplete
    field_template: Incomplete
    disable_csrf: bool
    use_custom_control: bool
    label_class: str
    field_class: str
    include_media: bool
    attrs: Incomplete
    inputs: Incomplete
    def __init__(self, form: Incomplete | None = None) -> None: ...
    def build_default_layout(self, form): ...
    @property
    def form_method(self): ...
    @form_method.setter
    def form_method(self, method) -> None: ...
    @property
    def form_action(self): ...
    @form_action.setter
    def form_action(self, action) -> None: ...
    @property
    def help_text_inline(self): ...
    @help_text_inline.setter
    def help_text_inline(self, flag) -> None: ...
    @property
    def error_text_inline(self): ...
    @error_text_inline.setter
    def error_text_inline(self, flag) -> None: ...
    def add_input(self, input_object) -> None: ...
    def add_layout(self, layout) -> None: ...
    def render_layout(self, form, context, template_pack=...): ...
    def get_attributes(self, template_pack=...): ...
